import { Items, ItemStack, world } from "mojang-minecraft";
import { ActionFormData } from "mojang-minecraft-ui";
world.events.beforeItemUse.subscribe(data => {
    if (data.source.id !== 'minecraft:player')
        return;
    if (data.item.id === 'pvz:menu') {
        shopMenu(data.source);
    }
});
const shopMenu = (player) => {
    const form = new ActionFormData();
        form.title("Main Menu")
        form.body("Version 2.3.3")
        form.button("Plants")
        form.button("Items")
        form.button("Bosses")
        form.button("Waves(coming soon)")
        form.button("Quests(coming soon)")
        form.button("Check Balance")
        form.button("Credits")
        form.button("Need help?")
        form.show(player).then((response) => {
        if (response.selection === 4) {
             player.runCommand("[]");
    }
        if (response.selection === 1) { shopItemGui(player)
    }
        if (response.selection === 3) {
             player.runCommand("[]");
    }
        if (response.selection === 6) { return shopCredits(player)
    }
        if (response.selection === 2) { return shopBosses(player)
    }
        if (response.selection === 5) { return shopBalance(player)
    }
        if (response.selection === 7) { return shopHelp(player)
    }
        if (response.selection === 0) return shopMenuPlants(player)
        })
    }
const shopBalance = (player) => {
    const form = new ActionFormData();
        form.title("Check Balance")
        form.body("Choose which one to show on your sidebar")
        form.button("Show Sun Balance")
        form.button("Show Coin Balance")
        form.button("Show Golden Coin Balance")
        form.button("Show Gem Balance")
        form.button("Back")
        form.show(player).then((response) => {
        if (response.selection === 0) {
             player.runCommand("scoreboard objectives setdisplay sidebar Sun ascending");
    }
        if (response.selection === 1) {
             player.runCommand("scoreboard objectives setdisplay sidebar Coins ascending");
    }
        if (response.selection === 2) {
             player.runCommand("scoreboard objectives setdisplay sidebar GoldCoins ascending");
    }
        if (response.selection === 3) {
             player.runCommand("scoreboard objectives setdisplay sidebar Gems ascending")
    }
        if (response.selection === 4) return shopMenu(player)
        })
    }
const shopMenuPlants = (player) => {
    const form = new ActionFormData();
        form.title("Plant Shop")
        form.body("AddonVersion2.3.2BetaVersion")
        form.button("Plants")
        form.button("Premium Plants")
        form.button("Back")
        form.show(player).then((response) => {
        if (response.selection === 0) { shopGui(player)
    }
        if (response.selection === 1) { return shopGuiPrem(player)
    }
        if (response.selection === 2) return shopMenu(player)
        })
    }
const shopHelp = (player) => {
    const form = new ActionFormData();
        form.title("Help Page")
        form.body("What do you need?")
        form.button("Recipes")
        form.button("Others")
        form.button("Back")
        form.show(player).then((response) => {
        if (response.selection === 0) { shopRecipes(player)
    }
        if (response.selection === 1) { return shopOthers(player)
    }
        if (response.selection === 2) return shopMenu(player)
        })
    }
const shopCredits = (player) => {
    const form = new ActionFormData();
        form.title("Credits")
        form.body("*Thank you very much to those people who helped us in the addon development !\n\n- iBlazed - scripting assistance\n\n- Nervie - for providing localization support, text & code optimization\n\n- The Phurko - for code optimization\n\n-  Esteban -\n\n- Noah22Nice - custom music discs & jukebox code\n\n- starting new -\n\n-RandomGhostPepper - for the item icons, spawn egg icons, models, and textures\n\n- Joshingtron - for sound design\n\n- Classixhali - for torchwood code\n\n*Creators of the musics featured in the pvz music discs\n\n- NikitaGamer64\n\n- Seiiccubus\n\n- Canal Joaco\n\n- dashersbeatz\n\n- liledix4\n\n- JoshingTron\n\n- Noteblock\n\n- Voup\n\n- J Rivers\n\n- Jonathan Romero\n\n- Mr. Papirin\n\n- Sindik")
        form.button("Back")
        form.show(player).then((response) => {
        if (response.selection === 0) return shopMenu(player)
        })
    }
const shopOthers = (player) => {
    const form = new ActionFormData();
        form.title("Others")
        form.body("Experimental Gameplay Settings to turn on:\n\n-Holiday Creator Features\n-Custom Biomes\n-Upcoming Creator Features\n-Gametest Framework\n-Molang Features\n\nCurrency System\nSun, Coins, and Gems will no longer stay in your inventory, after obtaining these currencies, it will automatically go on your scoreboard/sidebar.\nGo to Pvz Menu>Balance> to manage your balance display.\n\nSun\nSun will spawn naturally in the overworld, just wait for it.")
        form.button("Back")
        form.show(player).then((response) => {
        if (response.selection === 0) return shopMenu(player)
        })
    }
const shopRecipes = (player) => {
    const form = new ActionFormData();
        form.title("Recipes")
        form.body("*Item Recipes\n\n*Plants vs Zombies 2 Jukebox\n\nItems needed: Planks, Diamond\n\nLegend:\nPlanks (A)\nDiamond (B)\n\nPattern:\n\nA A A\nA B A\nA A A\n\n*Plants vs Zombies Main Menu\n\nItems needed: Book, Sun\n\nLegend:\nBook (A)\nSun (B)\n\nPattern:\n\nB A B\n* * *\n* * *\n\n*Garden Trolley\n\nItems needed: Planks, Dirt\n\nLegend:\nPlanks (A)\nDirt (B)\n\nPattern:\n\nA B A\nA A A\nA    A")
        form.button("Back")
        form.show(player).then((response) => {
        if (response.selection === 0) return shopMenu(player)
        })
    }
const shopItems = [{
        name: 'Sunflower §a$50',
        cost: 50,
        item: new ItemStack(Items.get('pvz:sunflower_packet'))
    }, {
        name: 'Peashooter §a$100',
        cost: 100,
        item: new ItemStack(Items.get('pvz:peashooter_packet'))
    }, {
        name: 'Wallnut §a$50',
        cost: 50,
        item: new ItemStack(Items.get('pvz:wallnut_packet'))
    }, {
        name: 'Potato Mine §a$25',
        cost: 25,
        item: new ItemStack(Items.get('pvz:potato_mine_packet'))
    }, {
        name: 'Cabbage Pult §a$100',
        cost: 100,
        item: new ItemStack(Items.get('pvz:cabbage_pult_packet'))
    }, {
        name: 'Bloomerang §a$175',
        cost: 175,
        item: new ItemStack(Items.get('pvz:bloomerang_packet'))
    }, {
        name: 'Iceberg Lettuce §a$0',
        cost: 0,
        item: new ItemStack(Items.get('pvz:iceberg_lettuce_packet'))
    }, {
        name: 'Gravebuster §a$0',
        cost: 0,
        item: new ItemStack(Items.get('pvz:gravebuster'))
    }, {
        name: 'Bonk Choy §a$150',
        cost: 150,
        item: new ItemStack(Items.get('pvz:bonk_choy_packet'))
    }, {
        name: 'Repeater §a$200',
        cost: 200,
        item: new ItemStack(Items.get('pvz:repeater_packet'))
    }, {
        name: 'Twin Sunflower §a$125',
        cost: 125,
        item: new ItemStack(Items.get('pvz:twin_sunflower_packet'))
    }, {
        name: 'Kernel Pult §a$100',
        cost: 100,
        item: new ItemStack(Items.get('pvz:kernel_pult_packet'))
    }, {
        name: 'Snapdragon §a$50',
        cost: 50,
        item: new ItemStack(Items.get('pvz:snapdragon_packet'))
    }, {
        name: 'Spikeweed §a$100',
        cost: 100,
        item: new ItemStack(Items.get('pvz:spikeweed_packet'))
    }, {
        name: 'Coconut Cannon §a$400',
        cost: 400,
        item: new ItemStack(Items.get('pvz:coconut_cannon_packet'))
    }, {
        name: 'Threepeater §a$325',
        cost: 325,
        item: new ItemStack(Items.get('pvz:threepeater_packet'))
    }, {
        name: 'Spikerock §a$225',
        cost: 225,
        item: new ItemStack(Items.get('pvz:spikerock_packet'))
    }, {
        name: 'Cherrybomb §a$150',
        cost: 150,
        item: new ItemStack(Items.get('pvz:cherrybomb_packet'))
    }, {
        name: 'Peapod §a$125',
        cost: 125,
        item: new ItemStack(Items.get('pvz:peapod_packet'))
    }, {
        name: 'Lightning Reed §a$125',
        cost: 125,
        item: new ItemStack(Items.get('pvz:lightning_reed_packet'))
    }, {
        name: 'Melon Pult §a$300',
        cost: 300,
        item: new ItemStack(Items.get('pvz:melon_pult_packet'))
    }, {
        name: 'Tallnut §a$125',
        cost: 125,
        item: new ItemStack(Items.get('pvz:tallnut_packet'))
    }, {
        name: 'Winter Melon §a$200',
        cost: 200,
        item: new ItemStack(Items.get('pvz:winter_melon_packet'))
    }, {
        name: 'Pepper Pult §a$200',
        cost: 200,
        item: new ItemStack(Items.get('pvz:pepper_pult_packet'))
    }, {
        name: 'Endurian §a$135',
        cost: 135,
        item: new ItemStack(Items.get('pvz:endurian_packet'))
    }, {
        name: 'Blover §a$50',
        cost: 50,
        item: new ItemStack(Items.get('pvz:blover_packet'))
    }, {
        name: 'Citron §a$350',
        cost: 350,
        item: new ItemStack(Items.get('pvz:citron_packet'))
    }, {
        name: 'Infinut §a$75',
        cost: 75,
        item: new ItemStack(Items.get('pvz:infinut_packet'))
    }, {
        name: 'Sunshroom §a$25',
        cost: 25,
        item: new ItemStack(Items.get('pvz:sunshroom_packet'))
    }, {
        name: 'Puffshroom §a$0',
        cost: 0,
        item: new ItemStack(Items.get('pvz:puffshroom_packet'))
    }, {
        name: 'Fumeshroom §a$125',
        cost: 125,
        item: new ItemStack(Items.get('pvz:fumeshroom_packet'))
    }, {
        name: 'Scaredyshroom §a$25',
        cost: 125,
        item: new ItemStack(Items.get('pvz:scaredyshroom_packet'))
    }, {
        name: 'Magnet Shroom §a$100',
        cost: 100,
        item: new ItemStack(Items.get('pvz:magnet_shroom_packet'))
    }, {
        name: 'Gold Magnetshroom §a$200',
        cost: 200,
        item: new ItemStack(Items.get('pvz:gold_magnet_packet'))
    }, {
        name: 'Plantern §a$25',
        cost: 25,
        item: new ItemStack(Items.get('pvz:plantern_packet'))
    }, {
        name: 'Iceshroom §a$75',
        cost: 75,
        item: new ItemStack(Items.get('pvz:iceshroom_packet'))
    }, {
        name: 'Phatbeet §a$150',
        cost: 150,
        item: new ItemStack(Items.get('pvz:phatbeet_packet'))
    }, {
        name: 'Electric Blueberry §a$150',
        cost: 150,
        item: new ItemStack(Items.get('pvz:electric_blueberry_packet'))
    }, {
        name: 'Lily Pad §a$25',
        cost: 25,
        item: new ItemStack(Items.get('pvz:lilypad_packet'))
    }, {
        name: 'Tangle Kelp §a$25',
        cost: 25,
        item: new ItemStack(Items.get('pvz:tangle_kelp_packet'))
    }, {
        name: 'Guacodile §a$125',
        cost: 125,
        item: new ItemStack(Items.get('pvz:guacodile_packet'))
    }, {
        name: 'Banana Launcher §a$500',
        cost: 500,
        item: new ItemStack(Items.get('pvz:banana_launcher_packet'))
    }, {
        name: 'Cob Cannon §a$500',
        cost: 500,
        item: new ItemStack(Items.get('pvz:cob_cannon_packet'))
    }, {
        name: 'Seashroom §a$0',
        cost: 0,
        item: new ItemStack(Items.get('pvz:seashroom_packet'))
    }, {
        name: 'Moonflower §a$50',
        cost: 50,
        item: new ItemStack(Items.get('pvz:moonflower_packet'))
    }, {
        name: 'Nightshade §a$75',
        cost: 75,
        item: new ItemStack(Items.get('pvz:nightshade_packet'))
    }, {
        name: 'Shadowshroom §a$50',
        cost: 50,
        item: new ItemStack(Items.get('pvz:shadowshroom_packet'))
    }, {
        name: 'Dusklobber §a$150',
        cost: 150,
        item: new ItemStack(Items.get('pvz:dusklobber_packet'))
    }, {
        name: 'Marigold §a$50',
        cost: 50,
        item: new ItemStack(Items.get('pvz:marigold_packet'))
    }, {
        name: 'Doomshroom §a$200',
        cost: 200,
        item: new ItemStack(Items.get('pvz:doomshroom_packet'))
    }];
const shopGui = (player) => {
    const gui = new ActionFormData();
    gui.title(`Shop`);
    gui.body('Currency: Sun');
    gui.button("Sunflower §a$50", "textures/plants_spawn/sunflower");
    gui.button("Peashooter §a$100", "textures/plants_spawn/peashooter");
    gui.button("Wallnut §a$50", "textures/plants_spawn/wallnut");
    gui.button("Potato Mine §a$25", "textures/plants_spawn/potato_mine");
    gui.button("Cabbage Pult §a$100", "textures/plants_spawn/cabbage_pult");
    gui.button("Bloomerang §a$175", "textures/plants_spawn/bloomerang");
    gui.button("Iceberg Lettuce §a$0", "textures/plants_spawn/iceberg_lettuce");
    gui.button("Gravebuster §a$0", "textures/plants_spawn/gravebuster_2");
    gui.button("Bonk Choy §a$150", "textures/plants_spawn/bonk_choy");
    gui.button("Repeater §a$200", "textures/plants_spawn/repeater");
    gui.button("Twin Sunflower §a$125", "textures/plants_spawn/twin_sunflower");
    gui.button("Kernel Pult §a$100", "textures/plants_spawn/kernel_pult");
    gui.button("Snapdragon §a$50", "textures/plants_spawn/snapdragon");
    gui.button("Spikeweed §a$100", "textures/plants_spawn/spikeweed");
    gui.button("Coconut Cannon §a$400", "textures/plants_spawn/coconut_cannon");
    gui.button("Threepeater §a$325", "textures/plants_spawn/threepeater");
    gui.button("Spikerock §a$225", "textures/plants_spawn/spikerock");
    gui.button("Cherrybomb §a$150", "textures/plants_spawn/cherrybomb");
    gui.button("Peapod §a$125", "textures/plants_spawn/peapod");
    gui.button("Lightning Reed §a$125", "textures/plants_spawn/lightning_reed");
    gui.button("Melon Pult §a$300", "textures/plants_spawn/melon_pult");
    gui.button("Tallnut §a$125", "textures/plants_spawn/tallnut");
    gui.button("Winter Melon §a$200", "textures/plants_spawn/winter_melon");
    gui.button("Pepper Pult §a$200", "textures/plants_spawn/pepper_pult");
    gui.button("Endrurian §a$135", "textures/plants_spawn/endurian");
    gui.button("Blover §a$50", "textures/plants_spawn/blover");
    gui.button("Citron §a$350", "textures/plants_spawn/citron");
    gui.button("Infinut §a$75", "textures/plants_spawn/infinut");
    gui.button("Sunshroom §a$25", "textures/plants_spawn/sunshroom");
    gui.button("Puffshroom §a$0", "textures/plants_spawn/puffshroom");
    gui.button("Fumeshroom §a$125", "textures/plants_spawn/fumeshroom");
    gui.button("Scaredyshroom §a$25", "textures/plants_spawn/scaredyshroom");
    gui.button("Magnetshroom §a$100", "textures/plants_spawn/magnet_shroom");
    gui.button("Gold Magnetshroom §a$200", "textures/plants_spawn/gold_magnet");
    gui.button("Plantern §a$25", "textures/plants_spawn/plantern");
    gui.button("Iceshroom §a$75", "textures/plants_spawn/ice");
    gui.button("Phatbeet §a$150", "textures/plants_spawn/phatbeet");
    gui.button("Electric Blueberry §a$150", "textures/plants_spawn/electric_blueberry");
    gui.button("Lilypad §a$25", "textures/plants_spawn/lilypad");
    gui.button("Tangle Kelp §a$25", "textures/plants_spawn/tangle_kelp");
    gui.button("Guacodile §a$125", "textures/plants_spawn/guacodile");
    gui.button("Banana Launcher §a$500", "textures/plants_spawn/banana_launcher");
    gui.button("Cob Cannon §a$500", "textures/plants_spawn/cob_cannon");
    gui.button("Seashroom §a$0", "textures/plants_spawn/seashroom");
    gui.button("Moonflower §a$50", "textures/plants_spawn/moonflower");
    gui.button("Nightshade §a$75", "textures/plants_spawn/nightshade");
    gui.button("Shadowshroom §a$50", "textures/plants_spawn/shadowshroom");
    gui.button("Dusklobber §a$150", "textures/plants_spawn/dusklobber");
    gui.button("Marigold §a$50", "textures/plants_spawn/marigold");
    gui.button("Doomshroom §a$200", "textures/plants_spawn/doomshroom");
    gui.show(player).then(result => { 
        if (result.isCancelled)
            return
        const money = getScore('Sun', player, true);
        const item = shopItems[result.selection];
        if (money < item.cost) {
            messagePlayer(player, `§cYou don't have enough sun to purchase that!`)
            return
        }
        messagePlayer(player, `§2You have purchased §a${item.name}`);
        player.runCommand(`scoreboard players remove @s Sun ${item.cost}`);
        player.getComponent('inventory').container.addItem(item.item);
    })
}
const shopItemItems = [{
        name: 'Garden Shovel §a$5',
        cost: 5,
        item: new ItemStack(Items.get('pvz:shovel'))
    }, {
        name: 'Bugspray §a$7',
        cost: 7,
        item: new ItemStack(Items.get('pvz:bugspray'))
    }, {
        name: 'Fertilizer §a$7',
        cost: 7,
        item: new ItemStack(Items.get('pvz:fertilizer'))
    }, {
        name: 'Phonograph §a$7',
        cost: 7,
        item: new ItemStack(Items.get('pvz:phonograph'))
    }, {
        name: 'Watering Can §a$7',
        cost: 7,
        item: new ItemStack(Items.get('pvz:watering_can'))
    }];
function shopItemGui(player) {
    let gui = new ActionFormData();
    gui.title(`Item Shop`);
    gui.body('Currency: Coins');
    gui.button("Garden Shovel §a$5");
    gui.button("Bugspray §a$7");
    gui.button("Fertilizer §a$7");
    gui.button("Phonograph §a$7");
    gui.button("Watering Can §a$7");
    gui.show(player).then(result => { 
        if (result.isCancelled)
            return
        const money = getScore('Coins', player, true);
        const item = shopItemItems[result.selection];
        if (money < item.cost) {
            messagePlayer(player, `§cYou don't have enough coins to purchase that!`)
            return
        }
        messagePlayer(player, `§2You have purchased §a${item.name}`);
        player.runCommand(`scoreboard players remove @s Coins ${item.cost}`);
        player.getComponent('inventory').container.addItem(item.item);
    })
}
const shopBossesItems = [{
        name: 'Zomboss §a$100',
        cost: 100,
        item: new ItemStack(Items.get('pvz:zomboss_spawn_egg'))
    }, {
        name: 'Zombot Sphinxinator §a$50',
        cost: 50,
        item: new ItemStack(Items.get('pvz:zombot_sphinx-inator_spawn_egg'))
    }];
function shopBosses(player) {
    let gui = new ActionFormData();
    gui.title(`Boss Shop`);
    gui.body('Currency: Gems');
    gui.button("Zomboss §a$100");
    gui.button("Zombot Sphinxinator §a$50");
    gui.show(player).then(result => { 
        if (result.isCancelled)
            return
        const money = getScore('Gems', player, true);
        const item = shopBossesItems[result.selection];
        if (money < item.cost) {
            messagePlayer(player, `§cYou don't have enough gems to purchase that!`)
            return
        }
        messagePlayer(player, `§2You have purchased §a${item.name}`);
        player.runCommand(`scoreboard players remove @s Gems ${item.cost}`);
        player.getComponent('inventory').container.addItem(item.item);
    })
}
const shopItemPremium = [{
        name: 'Snow Peashooter §a$75',
        cost: 175,
        item: new ItemStack(Items.get('pvz:snow_peashooter_packet'))
    }, {
        name: 'Squash §a$50',
        cost: 50,
        item: new ItemStack(Items.get('pvz:squash_packet'))
    }, {
        name: 'Jalapeno §a$25',
        cost: 125,
        item: new ItemStack(Items.get('pvz:jalapeno_packet'))
    }, {
        name: 'Hypnoshroom §a$25',
        cost: 125,
        item: new ItemStack(Items.get('pvz:hypnoshroom_packet'))
    }, {
        name: 'Peanut §a$50',
        cost: 150,
        item: new ItemStack(Items.get('pvz:peanut_packet'))
    }, {
        name: 'Chomper §a$50',
        cost: 150,
        item: new ItemStack(Items.get('pvz:chomper_packet'))
    }, {
        name: 'Lava Guava §a$75',
        cost: 75,
        item: new ItemStack(Items.get('pvz:lava_guava_packet'))
    }, {
        name: 'Toadstool §a$20',
        cost: 200,
        item: new ItemStack(Items.get('pvz:toadstool_packet'))
    }, {
        name: 'Fire Peashooter §a$25',
        cost: 125,
        item: new ItemStack(Items.get('pvz:fire_peashooter_packet'))
    }, {
        name: 'Cactus §a$75',
        cost: 175,
        item: new ItemStack(Items.get('pvz:cactus_packet'))
    }, {
        name: 'Cold Snapdragon §a$50',
        cost: 250,
        item: new ItemStack(Items.get('pvz:cold_snapdragon_packet'))
    }, {
        name: 'Wasabi Whip §a$50',
        cost: 150,
        item: new ItemStack(Items.get('pvz:wasabi_whip_packet'))
    }, {
        name: 'Apple Mortar §a$50',
        cost: 250,
        item: new ItemStack(Items.get('pvz:apple_mortar_packet'))
    }, {
        name: 'Electric Peashooter §a$20',
        cost: 200,
        item: new ItemStack(Items.get('pvz:electric_peashooter_packet'))
    }, {
        name: 'Gatling Peashooter §a$50',
        cost: 250,
        item: new ItemStack(Items.get('pvz:gatling_peashooter_packet'))
    }, {
        name: 'Torchwood §a$75',
        cost: 175,
        item: new ItemStack(Items.get('pvz:torchwood_packet'))
    }, {
        name: 'Starfruit §a$50',
        cost: 150,
        item: new ItemStack(Items.get('pvz:starfruit_packet'))
    }, {
        name: 'Explode O Nut §a$50',
        cost: 50,
        item: new ItemStack(Items.get('pvz:explode_o_nut_packet'))
    }, {
        name: 'Aloe §a$75',
        cost: 75,
        item: new ItemStack(Items.get('pvz:aloe_packet'))
    }, {
        name: 'Shadow Peashooter §a$25',
        cost: 125,
        item: new ItemStack(Items.get('pvz:shadow_peashooter_packet'))
    }, {
        name: 'Goo Peashooter §a$25',
        cost: 125,
        item: new ItemStack(Items.get('pvz:goo_peashooter_packet'))
    }, {
        name: 'Snap Pea §a$20',
        cost: 200,
        item: new ItemStack(Items.get('pvz:snappea_packet'))
    }, {
        name: 'Puffball §a$50',
        cost: 150,
        item: new ItemStack(Items.get('pvz:puffball_packet'))
    }, {
        name: 'Cattail §a$25',
        cost: 225,
        item: new ItemStack(Items.get('pvz:cattail_packet'))
    }, {
        name: 'Pumpkin Witch§a$50',
        cost: 250,
        item: new ItemStack(Items.get('pvz:pumpkin_witch_packet'))
    }];
function shopGuiPrem(player) {
    let gui = new ActionFormData();
    gui.title(`Premium Plants Shop`);
    gui.body('Currency: Gems');
    gui.button("Snow Peashooter §a$75", "textures/plants_spawn/snow_peashooter");
    gui.button("Squash §a$50", "textures/plants_spawn/squash");
    gui.button("Jalapeno §a$25", "textures/plants_spawn/jalapeno");
    gui.button("Hypnoshroom §a$25", "textures/plants_spawn/hypnoshroom");
    gui.button("Peanut §a$50", "textures/plants_spawn/peanut");
    gui.button("Chomper §a$50", "textures/plants_spawn/chomper");
    gui.button("Lava Guava §a$75", "textures/plants_spawn/lava_guava");
    gui.button("Toadstool §a$20", "textures/plants_spawn/toadstool");
    gui.button("Fire Peashooter §a$25", "textures/plants_spawn/fire_peashooter");
    gui.button("Cactus §a$75", "textures/plants_spawn/cactus");
    gui.button("Cold Snapdragon §a$50", "textures/plants_spawn/cold_snapdragon");
    gui.button("Wasabi Whip §a$50", "textures/plants_spawn/wasabi");
    gui.button("Apple Mortar §a$50", "textures/plants_spawn/apple_mortar");
    gui.button("Electric Peashooter §a$20", "textures/plants_spawn/electric_peashooter");
    gui.button("Gatling Peashooter §a$50", "textures/plants_spawn/gatling_peashooter");
    gui.button("Torchwood §a$75", "textures/plants_spawn/torchwood");
    gui.button("Starfruit §a$50", "textures/plants_spawn/starfruit");
    gui.button("Explode O Nut §a$50", "textures/plants_spawn/explode_o_nut");
    gui.button("Aloe §a$75", "textures/plants_spawn/aloe");
    gui.button("Shadow Peashooter §a$25", "textures/plants_spawn/shadow_peashooter");
    gui.button("Goo Peashooter §a$25", "textures/plants_spawn/goo_peashooter");
    gui.button("Snap Pea §a$20", "textures/plants_spawn/snappea");
    gui.button("Puffball §a$50", "textures/plants_spawn/puffball");
    gui.button("Cattail §a$25", "textures/plants_spawn/cattail");
    gui.button("Pumpkin Witch §a$50", "textures/plants_spawn/pumpkin_witch");
    gui.show(player).then(result => { 
        if (result.isCancelled)
            return
        const money = getScore('Gems', player, true);
        const item = shopItemPremium[result.selection];
        if (money < item.cost) {
            messagePlayer(player, `§cYou don't have enough gems to purchase that!`)
            return
        }
        messagePlayer(player, `§2You have purchased §a${item.name}`);
        player.runCommand(`scoreboard players remove @s Gems ${item.cost}`);
        player.getComponent('inventory').container.addItem(item.item);
    });

};
const getScore = (objective, target, useZero = false) => {
    try {
        const obj = world.scoreboard.getObjective(objective);
        if (typeof target == 'string')
            return obj.getScore(obj.getParticipants().find(v => v.displayName == target));
        return obj.getScore(target.scoreboard);
    }
    catch {
        return useZero ? 0 : NaN;
    }
};
const messagePlayer = (player, message) => {
    player.runCommand(`tellraw @s {"rawtext":[{"text":"${message}"}]}`);
};
let diamondAmount = 0
const inv = player.getComponent("inventory").container, { size } = inv
new Array(size).fill(undefined).forEach((e, i) => {
    const item = inv.getItem(i)
    if (item?.id === "minecraft:diamond") diamondAmount += item.amount
   })